
(define *code-streams* (make-deque))
(define *data-streams* (make-deque))

(define (adder-for-deque dq)
  (lambda (filename)
    (deque-enqueue! dq (if (equal? filename "-")
			 (current-input-port)
			 (open-input-file filename)))))

(define add-code-file (adder-for-deque *code-streams*))
(define add-data-file (adder-for-deque *data-streams*))

(define (port-deque->stream dq)
  (if (deque-empty? dq) snil
    (let construct ((port (deque-pop! dq)))
      (let ((c (read-char port)))
	(if (eof-object? c)
	  (if (deque-empty? dq) snil (construct (deque-pop! dq)))
	  (scons c (construct port)))))))

(define (read-b5-input)
  (let ((data1 (run-parser b5-program (port-deque->stream *code-streams*)))
	(data2 (run-parser b5-data (port-deque->stream *data-streams*))))
    (expr-combine data1 data2)))

